rebase-interactive: trim leading whitespace from progress count
[git.git] / git-rebase--interactive.sh
blob44ba3d30e271fe92a5a749612c722a8cbc5618c0
1 # This shell script fragment is sourced by git-rebase to implement
2 # its interactive mode. "git rebase --interactive" makes it easy
3 # to fix up commits in the middle of a series and rearrange commits.
5 # Copyright (c) 2006 Johannes E. Schindelin
7 # The original idea comes from Eric W. Biederman, in
8 # http://article.gmane.org/gmane.comp.version-control.git/22407
10 # The file containing rebase commands, comments, and empty lines.
11 # This file is created by "git rebase -i" then edited by the user. As
12 # the lines are processed, they are removed from the front of this
13 # file and written to the tail of $done.
14 todo="$state_dir"/git-rebase-todo
16 # The rebase command lines that have already been processed. A line
17 # is moved here when it is first handled, before any associated user
18 # actions.
19 done="$state_dir"/done
21 # The commit message that is planned to be used for any changes that
22 # need to be committed following a user interaction.
23 msg="$state_dir"/message
25 # The file into which is accumulated the suggested commit message for
26 # squash/fixup commands. When the first of a series of squash/fixups
27 # is seen, the file is created and the commit message from the
28 # previous commit and from the first squash/fixup commit are written
29 # to it. The commit message for each subsequent squash/fixup commit
30 # is appended to the file as it is processed.
32 # The first line of the file is of the form
33 # # This is a combination of $count commits.
34 # where $count is the number of commits whose messages have been
35 # written to the file so far (including the initial "pick" commit).
36 # Each time that a commit message is processed, this line is read and
37 # updated. It is deleted just before the combined commit is made.
38 squash_msg="$state_dir"/message-squash
40 # If the current series of squash/fixups has not yet included a squash
41 # command, then this file exists and holds the commit message of the
42 # original "pick" commit. (If the series ends without a "squash"
43 # command, then this can be used as the commit message of the combined
44 # commit without opening the editor.)
45 fixup_msg="$state_dir"/message-fixup
47 # $rewritten is the name of a directory containing files for each
48 # commit that is reachable by at least one merge base of $head and
49 # $upstream. They are not necessarily rewritten, but their children
50 # might be. This ensures that commits on merged, but otherwise
51 # unrelated side branches are left alone. (Think "X" in the man page's
52 # example.)
53 rewritten="$state_dir"/rewritten
55 dropped="$state_dir"/dropped
57 end="$state_dir"/end
58 msgnum="$state_dir"/msgnum
60 # A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
61 # GIT_AUTHOR_DATE that will be used for the commit that is currently
62 # being rebased.
63 author_script="$state_dir"/author-script
65 # When an "edit" rebase command is being processed, the SHA1 of the
66 # commit to be edited is recorded in this file. When "git rebase
67 # --continue" is executed, if there are any staged changes then they
68 # will be amended to the HEAD commit, but only provided the HEAD
69 # commit is still the commit to be edited. When any other rebase
70 # command is processed, this file is deleted.
71 amend="$state_dir"/amend
73 # For the post-rewrite hook, we make a list of rewritten commits and
74 # their new sha1s. The rewritten-pending list keeps the sha1s of
75 # commits that have been processed, but not committed yet,
76 # e.g. because they are waiting for a 'squash' command.
77 rewritten_list="$state_dir"/rewritten-list
78 rewritten_pending="$state_dir"/rewritten-pending
80 # Work around Git for Windows' Bash whose "read" does not strip CRLF
81 # and leaves CR at the end instead.
82 cr=$(printf "\015")
84 strategy_args=${strategy:+--strategy=$strategy}
85 test -n "$strategy_opts" &&
86 eval '
87 for strategy_opt in '"$strategy_opts"'
89 strategy_args="$strategy_args -X$(git rev-parse --sq-quote "${strategy_opt#--}")"
90 done
93 GIT_CHERRY_PICK_HELP="$resolvemsg"
94 export GIT_CHERRY_PICK_HELP
96 comment_char=$(git config --get core.commentchar 2>/dev/null | cut -c1)
97 : ${comment_char:=#}
99 warn () {
100 printf '%s\n' "$*" >&2
103 # Output the commit message for the specified commit.
104 commit_message () {
105 git cat-file commit "$1" | sed "1,/^$/d"
108 orig_reflog_action="$GIT_REFLOG_ACTION"
110 comment_for_reflog () {
111 case "$orig_reflog_action" in
112 ''|rebase*)
113 GIT_REFLOG_ACTION="rebase -i ($1)"
114 export GIT_REFLOG_ACTION
116 esac
119 last_count=
120 mark_action_done () {
121 sed -e 1q < "$todo" >> "$done"
122 sed -e 1d < "$todo" >> "$todo".new
123 mv -f "$todo".new "$todo"
124 new_count=$(( $(git stripspace --strip-comments <"$done" | wc -l) ))
125 echo $new_count >"$msgnum"
126 total=$(($new_count + $(git stripspace --strip-comments <"$todo" | wc -l)))
127 echo $total >"$end"
128 if test "$last_count" != "$new_count"
129 then
130 last_count=$new_count
131 eval_gettext "Rebasing (\$new_count/\$total)"; printf "\r"
132 test -z "$verbose" || echo
136 # Put the last action marked done at the beginning of the todo list
137 # again. If there has not been an action marked done yet, leave the list of
138 # items on the todo list unchanged.
139 reschedule_last_action () {
140 tail -n 1 "$done" | cat - "$todo" >"$todo".new
141 sed -e \$d <"$done" >"$done".new
142 mv -f "$todo".new "$todo"
143 mv -f "$done".new "$done"
146 append_todo_help () {
147 git stripspace --comment-lines >>"$todo" <<\EOF
149 Commands:
150 p, pick = use commit
151 r, reword = use commit, but edit the commit message
152 e, edit = use commit, but stop for amending
153 s, squash = use commit, but meld into previous commit
154 f, fixup = like "squash", but discard this commit's log message
155 x, exec = run command (the rest of the line) using shell
156 d, drop = remove commit
158 These lines can be re-ordered; they are executed from top to bottom.
161 if test $(get_missing_commit_check_level) = error
162 then
163 git stripspace --comment-lines >>"$todo" <<\EOF
164 Do not remove any line. Use 'drop' explicitly to remove a commit.
166 else
167 git stripspace --comment-lines >>"$todo" <<\EOF
168 If you remove a line here THAT COMMIT WILL BE LOST.
173 make_patch () {
174 sha1_and_parents="$(git rev-list --parents -1 "$1")"
175 case "$sha1_and_parents" in
176 ?*' '?*' '?*)
177 git diff --cc $sha1_and_parents
179 ?*' '?*)
180 git diff-tree -p "$1^!"
183 echo "Root commit"
185 esac > "$state_dir"/patch
186 test -f "$msg" ||
187 commit_message "$1" > "$msg"
188 test -f "$author_script" ||
189 get_author_ident_from_commit "$1" > "$author_script"
192 die_with_patch () {
193 echo "$1" > "$state_dir"/stopped-sha
194 make_patch "$1"
195 git rerere
196 die "$2"
199 exit_with_patch () {
200 echo "$1" > "$state_dir"/stopped-sha
201 make_patch $1
202 git rev-parse --verify HEAD > "$amend"
203 gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
204 warn "$(eval_gettext "\
205 You can amend the commit now, with
207 git commit --amend \$gpg_sign_opt_quoted
209 Once you are satisfied with your changes, run
211 git rebase --continue")"
212 warn
213 exit $2
216 die_abort () {
217 rm -rf "$state_dir"
218 die "$1"
221 has_action () {
222 test -n "$(git stripspace --strip-comments <"$1")"
225 is_empty_commit() {
226 tree=$(git rev-parse -q --verify "$1"^{tree} 2>/dev/null) || {
227 sha1=$1
228 die "$(eval_gettext "\$sha1: not a commit that can be picked")"
230 ptree=$(git rev-parse -q --verify "$1"^^{tree} 2>/dev/null) ||
231 ptree=4b825dc642cb6eb9a060e54bf8d69288fbee4904
232 test "$tree" = "$ptree"
235 is_merge_commit()
237 git rev-parse --verify --quiet "$1"^2 >/dev/null 2>&1
240 # Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
241 # GIT_AUTHOR_DATE exported from the current environment.
242 do_with_author () {
244 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
245 "$@"
249 git_sequence_editor () {
250 if test -z "$GIT_SEQUENCE_EDITOR"
251 then
252 GIT_SEQUENCE_EDITOR="$(git config sequence.editor)"
253 if [ -z "$GIT_SEQUENCE_EDITOR" ]
254 then
255 GIT_SEQUENCE_EDITOR="$(git var GIT_EDITOR)" || return $?
259 eval "$GIT_SEQUENCE_EDITOR" '"$@"'
262 pick_one () {
263 ff=--ff
265 case "$1" in -n) sha1=$2; ff= ;; *) sha1=$1 ;; esac
266 case "$force_rebase" in '') ;; ?*) ff= ;; esac
267 output git rev-parse --verify $sha1 || die "$(eval_gettext "Invalid commit name: \$sha1")"
269 if is_empty_commit "$sha1"
270 then
271 empty_args="--allow-empty"
274 test -d "$rewritten" &&
275 pick_one_preserving_merges "$@" && return
276 output eval git cherry-pick \
277 ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
278 "$strategy_args" $empty_args $ff "$@"
280 # If cherry-pick dies it leaves the to-be-picked commit unrecorded. Reschedule
281 # previous task so this commit is not lost.
282 ret=$?
283 case "$ret" in [01]) ;; *) reschedule_last_action ;; esac
284 return $ret
287 pick_one_preserving_merges () {
288 fast_forward=t
289 case "$1" in
291 fast_forward=f
292 sha1=$2
295 sha1=$1
297 esac
298 sha1=$(git rev-parse $sha1)
300 if test -f "$state_dir"/current-commit
301 then
302 if test "$fast_forward" = t
303 then
304 while read current_commit
306 git rev-parse HEAD > "$rewritten"/$current_commit
307 done <"$state_dir"/current-commit
308 rm "$state_dir"/current-commit ||
309 die "$(gettext "Cannot write current commit's replacement sha1")"
313 echo $sha1 >> "$state_dir"/current-commit
315 # rewrite parents; if none were rewritten, we can fast-forward.
316 new_parents=
317 pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
318 if test "$pend" = " "
319 then
320 pend=" root"
322 while [ "$pend" != "" ]
324 p=$(expr "$pend" : ' \([^ ]*\)')
325 pend="${pend# $p}"
327 if test -f "$rewritten"/$p
328 then
329 new_p=$(cat "$rewritten"/$p)
331 # If the todo reordered commits, and our parent is marked for
332 # rewriting, but hasn't been gotten to yet, assume the user meant to
333 # drop it on top of the current HEAD
334 if test -z "$new_p"
335 then
336 new_p=$(git rev-parse HEAD)
339 test $p != $new_p && fast_forward=f
340 case "$new_parents" in
341 *$new_p*)
342 ;; # do nothing; that parent is already there
344 new_parents="$new_parents $new_p"
346 esac
347 else
348 if test -f "$dropped"/$p
349 then
350 fast_forward=f
351 replacement="$(cat "$dropped"/$p)"
352 test -z "$replacement" && replacement=root
353 pend=" $replacement$pend"
354 else
355 new_parents="$new_parents $p"
358 done
359 case $fast_forward in
361 output warn "$(eval_gettext "Fast-forward to \$sha1")"
362 output git reset --hard $sha1 ||
363 die "$(eval_gettext "Cannot fast-forward to \$sha1")"
366 first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
368 if [ "$1" != "-n" ]
369 then
370 # detach HEAD to current parent
371 output git checkout $first_parent 2> /dev/null ||
372 die "$(eval_gettext "Cannot move HEAD to \$first_parent")"
375 case "$new_parents" in
376 ' '*' '*)
377 test "a$1" = a-n && die "$(eval_gettext "Refusing to squash a merge: \$sha1")"
379 # redo merge
380 author_script_content=$(get_author_ident_from_commit $sha1)
381 eval "$author_script_content"
382 msg_content="$(commit_message $sha1)"
383 # No point in merging the first parent, that's HEAD
384 new_parents=${new_parents# $first_parent}
385 merge_args="--no-log --no-ff"
386 if ! do_with_author output eval \
387 'git merge ${gpg_sign_opt:+"$gpg_sign_opt"} \
388 $merge_args $strategy_args -m "$msg_content" $new_parents'
389 then
390 printf "%s\n" "$msg_content" > "$GIT_DIR"/MERGE_MSG
391 die_with_patch $sha1 "$(eval_gettext "Error redoing merge \$sha1")"
393 echo "$sha1 $(git rev-parse HEAD^0)" >> "$rewritten_list"
396 output eval git cherry-pick \
397 ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
398 "$strategy_args" "$@" ||
399 die_with_patch $sha1 "$(eval_gettext "Could not pick \$sha1")"
401 esac
403 esac
406 nth_string () {
407 case "$1" in
408 *1[0-9]|*[04-9]) echo "$1"th;;
409 *1) echo "$1"st;;
410 *2) echo "$1"nd;;
411 *3) echo "$1"rd;;
412 esac
415 update_squash_messages () {
416 if test -f "$squash_msg"; then
417 mv "$squash_msg" "$squash_msg".bak || exit
418 count=$(($(sed -n \
419 -e "1s/^. This is a combination of \(.*\) commits\./\1/p" \
420 -e "q" < "$squash_msg".bak)+1))
422 printf '%s\n' "$comment_char This is a combination of $count commits."
423 sed -e 1d -e '2,/^./{
424 /^$/d
425 }' <"$squash_msg".bak
426 } >"$squash_msg"
427 else
428 commit_message HEAD > "$fixup_msg" || die "Cannot write $fixup_msg"
429 count=2
431 printf '%s\n' "$comment_char This is a combination of 2 commits."
432 printf '%s\n' "$comment_char The first commit's message is:"
433 echo
434 cat "$fixup_msg"
435 } >"$squash_msg"
437 case $1 in
438 squash)
439 rm -f "$fixup_msg"
440 echo
441 printf '%s\n' "$comment_char This is the $(nth_string $count) commit message:"
442 echo
443 commit_message $2
445 fixup)
446 echo
447 printf '%s\n' "$comment_char The $(nth_string $count) commit message will be skipped:"
448 echo
449 # Change the space after the comment character to TAB:
450 commit_message $2 | git stripspace --comment-lines | sed -e 's/ / /'
452 esac >>"$squash_msg"
455 peek_next_command () {
456 git stripspace --strip-comments <"$todo" | sed -n -e 's/ .*//p' -e q
459 # A squash/fixup has failed. Prepare the long version of the squash
460 # commit message, then die_with_patch. This code path requires the
461 # user to edit the combined commit message for all commits that have
462 # been squashed/fixedup so far. So also erase the old squash
463 # messages, effectively causing the combined commit to be used as the
464 # new basis for any further squash/fixups. Args: sha1 rest
465 die_failed_squash() {
466 sha1=$1
467 rest=$2
468 mv "$squash_msg" "$msg" || exit
469 rm -f "$fixup_msg"
470 cp "$msg" "$GIT_DIR"/MERGE_MSG || exit
471 warn
472 warn "$(eval_gettext "Could not apply \$sha1... \$rest")"
473 die_with_patch $sha1 ""
476 flush_rewritten_pending() {
477 test -s "$rewritten_pending" || return
478 newsha1="$(git rev-parse HEAD^0)"
479 sed "s/$/ $newsha1/" < "$rewritten_pending" >> "$rewritten_list"
480 rm -f "$rewritten_pending"
483 record_in_rewritten() {
484 oldsha1="$(git rev-parse $1)"
485 echo "$oldsha1" >> "$rewritten_pending"
487 case "$(peek_next_command)" in
488 squash|s|fixup|f)
491 flush_rewritten_pending
493 esac
496 do_pick () {
497 sha1=$1
498 rest=$2
499 if test "$(git rev-parse HEAD)" = "$squash_onto"
500 then
501 # Set the correct commit message and author info on the
502 # sentinel root before cherry-picking the original changes
503 # without committing (-n). Finally, update the sentinel again
504 # to include these changes. If the cherry-pick results in a
505 # conflict, this means our behaviour is similar to a standard
506 # failed cherry-pick during rebase, with a dirty index to
507 # resolve before manually running git commit --amend then git
508 # rebase --continue.
509 git commit --allow-empty --allow-empty-message --amend \
510 --no-post-rewrite -n -q -C $sha1 &&
511 pick_one -n $sha1 &&
512 git commit --allow-empty --allow-empty-message \
513 --amend --no-post-rewrite -n -q -C $sha1 \
514 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
515 die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
516 else
517 pick_one $sha1 ||
518 die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
522 do_next () {
523 rm -f "$msg" "$author_script" "$amend" "$state_dir"/stopped-sha || exit
524 read -r command sha1 rest < "$todo"
525 case "$command" in
526 "$comment_char"*|''|noop|drop|d)
527 mark_action_done
529 "$cr")
530 # Work around CR left by "read" (e.g. with Git for Windows' Bash).
531 mark_action_done
533 pick|p)
534 comment_for_reflog pick
536 mark_action_done
537 do_pick $sha1 "$rest"
538 record_in_rewritten $sha1
540 reword|r)
541 comment_for_reflog reword
543 mark_action_done
544 do_pick $sha1 "$rest"
545 git commit --amend --no-post-rewrite ${gpg_sign_opt:+"$gpg_sign_opt"} || {
546 warn "$(eval_gettext "\
547 Could not amend commit after successfully picking \$sha1... \$rest
548 This is most likely due to an empty commit message, or the pre-commit hook
549 failed. If the pre-commit hook failed, you may need to resolve the issue before
550 you are able to reword the commit.")"
551 exit_with_patch $sha1 1
553 record_in_rewritten $sha1
555 edit|e)
556 comment_for_reflog edit
558 mark_action_done
559 do_pick $sha1 "$rest"
560 sha1_abbrev=$(git rev-parse --short $sha1)
561 warn "$(eval_gettext "Stopped at \$sha1_abbrev... \$rest")"
562 exit_with_patch $sha1 0
564 squash|s|fixup|f)
565 case "$command" in
566 squash|s)
567 squash_style=squash
569 fixup|f)
570 squash_style=fixup
572 esac
573 comment_for_reflog $squash_style
575 test -f "$done" && has_action "$done" ||
576 die "$(eval_gettext "Cannot '\$squash_style' without a previous commit")"
578 mark_action_done
579 update_squash_messages $squash_style $sha1
580 author_script_content=$(get_author_ident_from_commit HEAD)
581 echo "$author_script_content" > "$author_script"
582 eval "$author_script_content"
583 if ! pick_one -n $sha1
584 then
585 git rev-parse --verify HEAD >"$amend"
586 die_failed_squash $sha1 "$rest"
588 case "$(peek_next_command)" in
589 squash|s|fixup|f)
590 # This is an intermediate commit; its message will only be
591 # used in case of trouble. So use the long version:
592 do_with_author output git commit --amend --no-verify -F "$squash_msg" \
593 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
594 die_failed_squash $sha1 "$rest"
597 # This is the final command of this squash/fixup group
598 if test -f "$fixup_msg"
599 then
600 do_with_author git commit --amend --no-verify -F "$fixup_msg" \
601 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
602 die_failed_squash $sha1 "$rest"
603 else
604 cp "$squash_msg" "$GIT_DIR"/SQUASH_MSG || exit
605 rm -f "$GIT_DIR"/MERGE_MSG
606 do_with_author git commit --amend --no-verify -F "$GIT_DIR"/SQUASH_MSG -e \
607 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
608 die_failed_squash $sha1 "$rest"
610 rm -f "$squash_msg" "$fixup_msg"
612 esac
613 record_in_rewritten $sha1
615 x|"exec")
616 read -r command rest < "$todo"
617 mark_action_done
618 eval_gettextln "Executing: \$rest"
619 "${SHELL:-@SHELL_PATH@}" -c "$rest" # Actual execution
620 status=$?
621 # Run in subshell because require_clean_work_tree can die.
622 dirty=f
623 (require_clean_work_tree "rebase" 2>/dev/null) || dirty=t
624 if test "$status" -ne 0
625 then
626 warn "$(eval_gettext "Execution failed: \$rest")"
627 test "$dirty" = f ||
628 warn "$(gettext "and made changes to the index and/or the working tree")"
630 warn "$(gettext "\
631 You can fix the problem, and then run
633 git rebase --continue")"
634 warn
635 if test $status -eq 127 # command not found
636 then
637 status=1
639 exit "$status"
640 elif test "$dirty" = t
641 then
642 # TRANSLATORS: after these lines is a command to be issued by the user
643 warn "$(eval_gettext "\
644 Execution succeeded: \$rest
645 but left changes to the index and/or the working tree
646 Commit or stash your changes, and then run
648 git rebase --continue")"
649 warn
650 exit 1
654 warn "$(eval_gettext "Unknown command: \$command \$sha1 \$rest")"
655 fixtodo="$(gettext "Please fix this using 'git rebase --edit-todo'.")"
656 if git rev-parse --verify -q "$sha1" >/dev/null
657 then
658 die_with_patch $sha1 "$fixtodo"
659 else
660 die "$fixtodo"
663 esac
664 test -s "$todo" && return
666 comment_for_reflog finish &&
667 newhead=$(git rev-parse HEAD) &&
668 case $head_name in
669 refs/*)
670 message="$GIT_REFLOG_ACTION: $head_name onto $onto" &&
671 git update-ref -m "$message" $head_name $newhead $orig_head &&
672 git symbolic-ref \
673 -m "$GIT_REFLOG_ACTION: returning to $head_name" \
674 HEAD $head_name
676 esac && {
677 test ! -f "$state_dir"/verbose ||
678 git diff-tree --stat $orig_head..HEAD
679 } &&
681 test -s "$rewritten_list" &&
682 git notes copy --for-rewrite=rebase < "$rewritten_list" ||
683 true # we don't care if this copying failed
684 } &&
685 hook="$(git rev-parse --git-path hooks/post-rewrite)"
686 if test -x "$hook" && test -s "$rewritten_list"; then
687 "$hook" rebase < "$rewritten_list"
688 true # we don't care if this hook failed
689 fi &&
690 warn "$(eval_gettext "Successfully rebased and updated \$head_name.")"
692 return 1 # not failure; just to break the do_rest loop
695 # can only return 0, when the infinite loop breaks
696 do_rest () {
697 while :
699 do_next || break
700 done
703 # skip picking commits whose parents are unchanged
704 skip_unnecessary_picks () {
705 fd=3
706 while read -r command rest
708 # fd=3 means we skip the command
709 case "$fd,$command" in
710 3,pick|3,p)
711 # pick a commit whose parent is current $onto -> skip
712 sha1=${rest%% *}
713 case "$(git rev-parse --verify --quiet "$sha1"^)" in
714 "$onto"*)
715 onto=$sha1
718 fd=1
720 esac
722 3,"$comment_char"*|3,)
723 # copy comments
726 fd=1
728 esac
729 printf '%s\n' "$command${rest:+ }$rest" >&$fd
730 done <"$todo" >"$todo.new" 3>>"$done" &&
731 mv -f "$todo".new "$todo" &&
732 case "$(peek_next_command)" in
733 squash|s|fixup|f)
734 record_in_rewritten "$onto"
736 esac ||
737 die "$(gettext "Could not skip unnecessary pick commands")"
740 transform_todo_ids () {
741 while read -r command rest
743 case "$command" in
744 "$comment_char"* | exec)
745 # Be careful for oddball commands like 'exec'
746 # that do not have a SHA-1 at the beginning of $rest.
749 sha1=$(git rev-parse --verify --quiet "$@" ${rest%%[ ]*}) &&
750 rest="$sha1 ${rest#*[ ]}"
752 esac
753 printf '%s\n' "$command${rest:+ }$rest"
754 done <"$todo" >"$todo.new" &&
755 mv -f "$todo.new" "$todo"
758 expand_todo_ids() {
759 transform_todo_ids
762 collapse_todo_ids() {
763 transform_todo_ids --short
766 # Rearrange the todo list that has both "pick sha1 msg" and
767 # "pick sha1 fixup!/squash! msg" appears in it so that the latter
768 # comes immediately after the former, and change "pick" to
769 # "fixup"/"squash".
771 # Note that if the config has specified a custom instruction format
772 # each log message will be re-retrieved in order to normalize the
773 # autosquash arrangement
774 rearrange_squash () {
775 # extract fixup!/squash! lines and resolve any referenced sha1's
776 while read -r pick sha1 message
778 test -z "${format}" || message=$(git log -n 1 --format="%s" ${sha1})
779 case "$message" in
780 "squash! "*|"fixup! "*)
781 action="${message%%!*}"
782 rest=$message
783 prefix=
784 # skip all squash! or fixup! (but save for later)
785 while :
787 case "$rest" in
788 "squash! "*|"fixup! "*)
789 prefix="$prefix${rest%%!*},"
790 rest="${rest#*! }"
793 break
795 esac
796 done
797 printf '%s %s %s %s\n' "$sha1" "$action" "$prefix" "$rest"
798 # if it's a single word, try to resolve to a full sha1 and
799 # emit a second copy. This allows us to match on both message
800 # and on sha1 prefix
801 if test "${rest#* }" = "$rest"; then
802 fullsha="$(git rev-parse -q --verify "$rest" 2>/dev/null)"
803 if test -n "$fullsha"; then
804 # prefix the action to uniquely identify this line as
805 # intended for full sha1 match
806 echo "$sha1 +$action $prefix $fullsha"
809 esac
810 done >"$1.sq" <"$1"
811 test -s "$1.sq" || return
813 used=
814 while read -r pick sha1 message
816 case " $used" in
817 *" $sha1 "*) continue ;;
818 esac
819 printf '%s\n' "$pick $sha1 $message"
820 test -z "${format}" || message=$(git log -n 1 --format="%s" ${sha1})
821 used="$used$sha1 "
822 while read -r squash action msg_prefix msg_content
824 case " $used" in
825 *" $squash "*) continue ;;
826 esac
827 emit=0
828 case "$action" in
830 action="${action#+}"
831 # full sha1 prefix test
832 case "$msg_content" in "$sha1"*) emit=1;; esac ;;
834 # message prefix test
835 case "$message" in "$msg_content"*) emit=1;; esac ;;
836 esac
837 if test $emit = 1; then
838 if test -n "${format}"
839 then
840 msg_content=$(git log -n 1 --format="${format}" ${squash})
841 else
842 msg_content="$(echo "$msg_prefix" | sed "s/,/! /g")$msg_content"
844 printf '%s\n' "$action $squash $msg_content"
845 used="$used$squash "
847 done <"$1.sq"
848 done >"$1.rearranged" <"$1"
849 cat "$1.rearranged" >"$1"
850 rm -f "$1.sq" "$1.rearranged"
853 # Add commands after a pick or after a squash/fixup serie
854 # in the todo list.
855 add_exec_commands () {
857 first=t
858 while read -r insn rest
860 case $insn in
861 pick)
862 test -n "$first" ||
863 printf "%s" "$cmd"
865 esac
866 printf "%s %s\n" "$insn" "$rest"
867 first=
868 done
869 printf "%s" "$cmd"
870 } <"$1" >"$1.new" &&
871 mv "$1.new" "$1"
874 # Check if the SHA-1 passed as an argument is a
875 # correct one, if not then print $2 in "$todo".badsha
876 # $1: the SHA-1 to test
877 # $2: the line number of the input
878 # $3: the input filename
879 check_commit_sha () {
880 badsha=0
881 if test -z "$1"
882 then
883 badsha=1
884 else
885 sha1_verif="$(git rev-parse --verify --quiet $1^{commit})"
886 if test -z "$sha1_verif"
887 then
888 badsha=1
892 if test $badsha -ne 0
893 then
894 line="$(sed -n -e "${2}p" "$3")"
895 warn "$(eval_gettext "\
896 Warning: the SHA-1 is missing or isn't a commit in the following line:
897 - \$line")"
898 warn
901 return $badsha
904 # prints the bad commits and bad commands
905 # from the todolist in stdin
906 check_bad_cmd_and_sha () {
907 retval=0
908 lineno=0
909 while read -r command rest
911 lineno=$(( $lineno + 1 ))
912 case $command in
913 "$comment_char"*|''|noop|x|exec)
914 # Doesn't expect a SHA-1
916 "$cr")
917 # Work around CR left by "read" (e.g. with Git for
918 # Windows' Bash).
920 pick|p|drop|d|reword|r|edit|e|squash|s|fixup|f)
921 if ! check_commit_sha "${rest%%[ ]*}" "$lineno" "$1"
922 then
923 retval=1
927 line="$(sed -n -e "${lineno}p" "$1")"
928 warn "$(eval_gettext "\
929 Warning: the command isn't recognized in the following line:
930 - \$line")"
931 warn
932 retval=1
934 esac
935 done <"$1"
936 return $retval
939 # Print the list of the SHA-1 of the commits
940 # from stdin to stdout
941 todo_list_to_sha_list () {
942 git stripspace --strip-comments |
943 while read -r command sha1 rest
945 case $command in
946 "$comment_char"*|''|noop|x|"exec")
949 long_sha=$(git rev-list --no-walk "$sha1" 2>/dev/null)
950 printf "%s\n" "$long_sha"
952 esac
953 done
956 # Use warn for each line in stdin
957 warn_lines () {
958 while read -r line
960 warn " - $line"
961 done
964 # Switch to the branch in $into and notify it in the reflog
965 checkout_onto () {
966 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name"
967 output git checkout $onto || die_abort "$(gettext "could not detach HEAD")"
968 git update-ref ORIG_HEAD $orig_head
971 get_missing_commit_check_level () {
972 check_level=$(git config --get rebase.missingCommitsCheck)
973 check_level=${check_level:-ignore}
974 # Don't be case sensitive
975 printf '%s' "$check_level" | tr 'A-Z' 'a-z'
978 # Check if the user dropped some commits by mistake
979 # Behaviour determined by rebase.missingCommitsCheck.
980 # Check if there is an unrecognized command or a
981 # bad SHA-1 in a command.
982 check_todo_list () {
983 raise_error=f
985 check_level=$(get_missing_commit_check_level)
987 case "$check_level" in
988 warn|error)
989 # Get the SHA-1 of the commits
990 todo_list_to_sha_list <"$todo".backup >"$todo".oldsha1
991 todo_list_to_sha_list <"$todo" >"$todo".newsha1
993 # Sort the SHA-1 and compare them
994 sort -u "$todo".oldsha1 >"$todo".oldsha1+
995 mv "$todo".oldsha1+ "$todo".oldsha1
996 sort -u "$todo".newsha1 >"$todo".newsha1+
997 mv "$todo".newsha1+ "$todo".newsha1
998 comm -2 -3 "$todo".oldsha1 "$todo".newsha1 >"$todo".miss
1000 # Warn about missing commits
1001 if test -s "$todo".miss
1002 then
1003 test "$check_level" = error && raise_error=t
1005 warn "$(gettext "\
1006 Warning: some commits may have been dropped accidentally.
1007 Dropped commits (newer to older):")"
1009 # Make the list user-friendly and display
1010 opt="--no-walk=sorted --format=oneline --abbrev-commit --stdin"
1011 git rev-list $opt <"$todo".miss | warn_lines
1013 warn "$(gettext "\
1014 To avoid this message, use \"drop\" to explicitly remove a commit.
1016 Use 'git config rebase.missingCommitsCheck' to change the level of warnings.
1017 The possible behaviours are: ignore, warn, error.")"
1018 warn
1021 ignore)
1024 warn "$(eval_gettext "Unrecognized setting \$check_level for option rebase.missingCommitsCheck. Ignoring.")"
1026 esac
1028 if ! check_bad_cmd_and_sha "$todo"
1029 then
1030 raise_error=t
1033 if test $raise_error = t
1034 then
1035 # Checkout before the first commit of the
1036 # rebase: this way git rebase --continue
1037 # will work correctly as it expects HEAD to be
1038 # placed before the commit of the next action
1039 checkout_onto
1041 warn "$(gettext "You can fix this with 'git rebase --edit-todo'.")"
1042 die "$(gettext "Or you can abort the rebase with 'git rebase --abort'.")"
1046 # The whole contents of this file is run by dot-sourcing it from
1047 # inside a shell function. It used to be that "return"s we see
1048 # below were not inside any function, and expected to return
1049 # to the function that dot-sourced us.
1051 # However, FreeBSD /bin/sh misbehaves on such a construct and
1052 # continues to run the statements that follow such a "return".
1053 # As a work-around, we introduce an extra layer of a function
1054 # here, and immediately call it after defining it.
1055 git_rebase__interactive () {
1057 case "$action" in
1058 continue)
1059 # do we have anything to commit?
1060 if git diff-index --cached --quiet HEAD --
1061 then
1062 # Nothing to commit -- skip this commit
1064 test ! -f "$GIT_DIR"/CHERRY_PICK_HEAD ||
1065 rm "$GIT_DIR"/CHERRY_PICK_HEAD ||
1066 die "$(gettext "Could not remove CHERRY_PICK_HEAD")"
1067 else
1068 if ! test -f "$author_script"
1069 then
1070 gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
1071 die "$(eval_gettext "\
1072 You have staged changes in your working tree.
1073 If these changes are meant to be
1074 squashed into the previous commit, run:
1076 git commit --amend \$gpg_sign_opt_quoted
1078 If they are meant to go into a new commit, run:
1080 git commit \$gpg_sign_opt_quoted
1082 In both case, once you're done, continue with:
1084 git rebase --continue
1087 . "$author_script" ||
1088 die "$(gettext "Error trying to find the author identity to amend commit")"
1089 if test -f "$amend"
1090 then
1091 current_head=$(git rev-parse --verify HEAD)
1092 test "$current_head" = $(cat "$amend") ||
1093 die "$(gettext "\
1094 You have uncommitted changes in your working tree. Please commit them
1095 first and then run 'git rebase --continue' again.")"
1096 do_with_author git commit --amend --no-verify -F "$msg" -e \
1097 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
1098 die "$(gettext "Could not commit staged changes.")"
1099 else
1100 do_with_author git commit --no-verify -F "$msg" -e \
1101 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
1102 die "$(gettext "Could not commit staged changes.")"
1106 if test -r "$state_dir"/stopped-sha
1107 then
1108 record_in_rewritten "$(cat "$state_dir"/stopped-sha)"
1111 require_clean_work_tree "rebase"
1112 do_rest
1113 return 0
1115 skip)
1116 git rerere clear
1118 do_rest
1119 return 0
1121 edit-todo)
1122 git stripspace --strip-comments <"$todo" >"$todo".new
1123 mv -f "$todo".new "$todo"
1124 collapse_todo_ids
1125 append_todo_help
1126 git stripspace --comment-lines >>"$todo" <<\EOF
1128 You are editing the todo file of an ongoing interactive rebase.
1129 To continue rebase after editing, run:
1130 git rebase --continue
1134 git_sequence_editor "$todo" ||
1135 die "$(gettext "Could not execute editor")"
1136 expand_todo_ids
1138 exit
1140 esac
1142 git var GIT_COMMITTER_IDENT >/dev/null ||
1143 die "$(gettext "You need to set your committer info first")"
1145 comment_for_reflog start
1147 if test ! -z "$switch_to"
1148 then
1149 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to"
1150 output git checkout "$switch_to" -- ||
1151 die "$(eval_gettext "Could not checkout \$switch_to")"
1153 comment_for_reflog start
1156 orig_head=$(git rev-parse --verify HEAD) || die "$(gettext "No HEAD?")"
1157 mkdir -p "$state_dir" || die "$(eval_gettext "Could not create temporary \$state_dir")"
1159 : > "$state_dir"/interactive || die "$(gettext "Could not mark as interactive")"
1160 write_basic_state
1161 if test t = "$preserve_merges"
1162 then
1163 if test -z "$rebase_root"
1164 then
1165 mkdir "$rewritten" &&
1166 for c in $(git merge-base --all $orig_head $upstream)
1168 echo $onto > "$rewritten"/$c ||
1169 die "$(gettext "Could not init rewritten commits")"
1170 done
1171 else
1172 mkdir "$rewritten" &&
1173 echo $onto > "$rewritten"/root ||
1174 die "$(gettext "Could not init rewritten commits")"
1176 # No cherry-pick because our first pass is to determine
1177 # parents to rewrite and skipping dropped commits would
1178 # prematurely end our probe
1179 merges_option=
1180 else
1181 merges_option="--no-merges --cherry-pick"
1184 shorthead=$(git rev-parse --short $orig_head)
1185 shortonto=$(git rev-parse --short $onto)
1186 if test -z "$rebase_root"
1187 # this is now equivalent to ! -z "$upstream"
1188 then
1189 shortupstream=$(git rev-parse --short $upstream)
1190 revisions=$upstream...$orig_head
1191 shortrevisions=$shortupstream..$shorthead
1192 else
1193 revisions=$onto...$orig_head
1194 shortrevisions=$shorthead
1196 format=$(git config --get rebase.instructionFormat)
1197 # the 'rev-list .. | sed' requires %m to parse; the instruction requires %H to parse
1198 git rev-list $merges_option --format="%m%H ${format:-%s}" \
1199 --reverse --left-right --topo-order \
1200 $revisions ${restrict_revision+^$restrict_revision} | \
1201 sed -n "s/^>//p" |
1202 while read -r sha1 rest
1205 if test -z "$keep_empty" && is_empty_commit $sha1 && ! is_merge_commit $sha1
1206 then
1207 comment_out="$comment_char "
1208 else
1209 comment_out=
1212 if test t != "$preserve_merges"
1213 then
1214 printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
1215 else
1216 if test -z "$rebase_root"
1217 then
1218 preserve=t
1219 for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
1221 if test -f "$rewritten"/$p
1222 then
1223 preserve=f
1225 done
1226 else
1227 preserve=f
1229 if test f = "$preserve"
1230 then
1231 touch "$rewritten"/$sha1
1232 printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
1235 done
1237 # Watch for commits that been dropped by --cherry-pick
1238 if test t = "$preserve_merges"
1239 then
1240 mkdir "$dropped"
1241 # Save all non-cherry-picked changes
1242 git rev-list $revisions --left-right --cherry-pick | \
1243 sed -n "s/^>//p" > "$state_dir"/not-cherry-picks
1244 # Now all commits and note which ones are missing in
1245 # not-cherry-picks and hence being dropped
1246 git rev-list $revisions |
1247 while read rev
1249 if test -f "$rewritten"/$rev &&
1250 ! sane_grep "$rev" "$state_dir"/not-cherry-picks >/dev/null
1251 then
1252 # Use -f2 because if rev-list is telling us this commit is
1253 # not worthwhile, we don't want to track its multiple heads,
1254 # just the history of its first-parent for others that will
1255 # be rebasing on top of it
1256 git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$dropped"/$rev
1257 sha1=$(git rev-list -1 $rev)
1258 sane_grep -v "^[a-z][a-z]* $sha1" <"$todo" > "${todo}2" ; mv "${todo}2" "$todo"
1259 rm "$rewritten"/$rev
1261 done
1264 test -s "$todo" || echo noop >> "$todo"
1265 test -n "$autosquash" && rearrange_squash "$todo"
1266 test -n "$cmd" && add_exec_commands "$todo"
1268 todocount=$(git stripspace --strip-comments <"$todo" | wc -l)
1269 todocount=${todocount##* }
1271 cat >>"$todo" <<EOF
1273 $comment_char Rebase $shortrevisions onto $shortonto ($todocount command(s))
1275 append_todo_help
1276 git stripspace --comment-lines >>"$todo" <<\EOF
1278 However, if you remove everything, the rebase will be aborted.
1282 if test -z "$keep_empty"
1283 then
1284 printf '%s\n' "$comment_char $(gettext "Note that empty commits are commented out")" >>"$todo"
1288 has_action "$todo" ||
1289 return 2
1291 cp "$todo" "$todo".backup
1292 collapse_todo_ids
1293 git_sequence_editor "$todo" ||
1294 die_abort "$(gettext "Could not execute editor")"
1296 has_action "$todo" ||
1297 return 2
1299 check_todo_list
1301 expand_todo_ids
1303 test -d "$rewritten" || test -n "$force_rebase" || skip_unnecessary_picks
1305 checkout_onto
1306 do_rest
1309 # ... and then we call the whole thing.
1310 git_rebase__interactive